unit hitarEasyType;

interface

uses KOL, Share, Debug;

type
  TEventMode = (emEmptyList, emFilledList, emAliases, emForAll, emDisabled);

type
  THitarEasyType = class(TDebug)  // class(THiStrList) ???
  private
    FComp: PList;
    FList: PStrList;
    FIndex: integer;
    FString, FAlias: string;

    Arr: PArray;
    procedure _Set(var Item: TData; var Val: TData);
    function _Get(var Item: TData; var Val: TData): boolean;
    function _Count: integer;
    procedure _Add(var Val: TData);
    
    procedure Init;
  public
    _event_onGetCompletion: THi_Event;
     
    _prop_EventMode: TEventMode;
    _prop_AddAliasName: boolean;
//    _prop_Char: string;
    
    constructor Create; reintroduce;
    destructor Destroy; override;

    procedure _work_doAdd(var _Data: TData; Index: word);
    procedure _work_doDelete(var _Data: TData; Index: word);
    procedure _work_doClear(var _Data: TData; Index: word);
    
    procedure _var_Array(var _Data: TData; Index: word);
    procedure _var_String(var _Data: TData; Index: word);
    procedure _var_Index(var _Data: TData; Index: word);
    procedure _var_ParamIndex(var _Data: TData; Index: word);
  end;
  
function GetCountET(str: PChar): integer; cdecl; 
function GetStringET(idx: integer): PChar; cdecl; 

exports
  GetCountET,
  GetStringET;

implementation

uses
  hiTAR;
  
var
  Obj: THitarEasyType;
  
function GetCountET;
var
  k: integer;
  s: string;
begin
  with Obj do
    begin
      FList.Clear;
      FString := str;
      if _prop_EventMode in [emEmptyList, emFilledList, emAliases, emDisabled] then
        begin
          s := str;
          k := Pos(' ', s);
          if k > 0 then
            Delete(s, k, Length(s) - k + 1);
          s := trim(s);
          FAlias := s;
          FIndex := IndexOf_NoCase(ProjectClass.Aliases, s);
          if FComp.Items[FIndex] <> nil then
            FList.Assign(FComp.Items[FIndex]);
          if (FIndex <> -1) and (_prop_EventMode <> emDisabled) and 
           ((_prop_EventMode = emAliases) or ((FComp.Items[FIndex] = nil) xor (_prop_EventMode = emFilledList))) then
             _hi_onEvent(_event_onGetCompletion, FIndex);
        end
      else
        begin
          FIndex := -1;
          FAlias := '';
          _hi_onEvent(_event_onGetCompletion, FString);
        end; 
      Result := FList.Count;
    end;
end;

function GetStringET;
begin
  if Obj.FAlias <> '' then
    Result := PChar(_Trim(Obj.FAlias + ' ' + Obj.FList.Items[idx] + ''))
  else
    Result := Obj.FList.ItemPtrs[idx];
end;

constructor THitarEasyType.Create;
begin
  inherited;
  Obj := self;
  FList := NewStrList;
  FComp := NewList;
  InitAdd(Init);
end;

destructor THitarEasyType.Destroy;
begin
  FList.Free;
  FComp.Release; 
  inherited;
end;

procedure THitarEasyType.Init;
var
  i: integer;
  s: string;
  c: char;
  List: PStrList;
begin
{  if Length(_prop_Char) > 0 then
    c := _prop_Char[1]
  else     }
    c := ':';
  for i := 0 to ProjectClass.Aliases.Count - 1 do
    begin
      s := ProjectClass.Aliases.Items[i];
      if Pos(c, s) > 0 then
        begin
          ProjectClass.Aliases.Items[i] := GetTok(s, c);
          List := NewStrList;
          repeat
            if Pos(',', s) > 0 then
              List.Add(_Trim(GetTok(s, ',')))
            else
              begin
                List.Add(s);
                s := '';
              end;
          until s = '';
        end
      else
        List := nil;
      FComp.Add(List);
    end;
end;

procedure THitarEasyType._work_doAdd;
begin
  FList.Add(ToString(_Data));
end;

procedure THitarEasyType._work_doDelete;
var
  idx: integer;
begin
   idx := ToIntIndex(_Data);
   if (idx >= 0) and (idx < FList.Count) then
     FList.Delete(idx);
end;

procedure THitarEasyType._work_doClear;
begin
  FList.Clear;
end;

procedure THitarEasyType._var_Index;
begin
  dtInteger(_Data, FIndex);
end;

procedure THitarEasyType._var_String;
begin
  dtString(_Data, FString);
end;

procedure THitarEasyType._Set;
var
  idx:integer;
begin
  idx := ToIntIndex(Item);
  if(idx >= 0) and (idx < FList.Count) then
    FList.Items[idx] := ToString(Val);
end;

procedure THitarEasyType._Add;
begin
  FList.Add(ToString(Val));
end;

function THitarEasyType._Get;
var
  idx: integer;
begin
   idx := ToIntIndex(Item);
   if(idx >= 0) and (idx < FList.Count) then
     begin
       Result := true;
       dtString(Val, FList.Items[idx]);
     end
   else Result := false;
end;

function THitarEasyType._Count;
begin
  Result := FList.Count;
end;

procedure THitarEasyType._var_Array;
begin
   if Arr = nil then
      Arr := CreateArray(_Set, _Get, _Count, _Add);
   dtArray(_Data, Arr);
end;

procedure THitarEasyType._var_ParamIndex;
begin
  with ProjectClass do
    if (Alias <> -1) and (Params.Count > 1) and (FComp.Items[Alias] <> nil) then
      dtInteger(_Data, IndexOf_NoCase(FComp.Items[Alias], Params.Items[1]))
    else
      dtInteger(_Data, -1)
end;

end.
